diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/classification/TaxonNodeDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/classification/TaxonNodeDetailElement.java
index f0472fffa..510aef975 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/classification/TaxonNodeDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/classification/TaxonNodeDetailElement.java
@@ -20,16 +20,12 @@ import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonNode;
 import eu.etaxonomy.taxeditor.parser.ParseHandler;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.CdmPropertyChangeEvent;
 import eu.etaxonomy.taxeditor.ui.element.CheckboxElement;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.ClassificationSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.NameSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 import eu.etaxonomy.taxeditor.ui.selection.TaxonNodeSelectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.TaxonSelectionElement;
 
 /**
  * <p>
@@ -42,7 +38,7 @@ import eu.etaxonomy.taxeditor.ui.selection.TaxonSelectionElement;
  */
 public class TaxonNodeDetailElement extends AbstractCdmDetailElement<ITreeNode> {
 
-	private ClassificationSelectionElement selection_classification;
+	private EntitySelectionElement<Classification> selection_classification;
 
 	private Classification classification;
 
@@ -50,7 +46,7 @@ public class TaxonNodeDetailElement extends AbstractCdmDetailElement<ITreeNode>
 
 	private ITreeNode parentTreeNode;
 
-	private TaxonSelectionElement selection_reuseExistingTaxon;
+	private EntitySelectionElement<Taxon> selection_reuseExistingTaxon;
 
 	private Taxon taxon;
 
@@ -62,7 +58,7 @@ public class TaxonNodeDetailElement extends AbstractCdmDetailElement<ITreeNode>
 
 	private boolean complete;
 
-	private NameSelectionElement selection_reuseExistingName;
+	private EntitySelectionElement<TaxonNameBase> selection_reuseExistingName;
 
 	/**
 	 * <p>
@@ -93,25 +89,24 @@ public class TaxonNodeDetailElement extends AbstractCdmDetailElement<ITreeNode>
 	@Override
 	protected void createControls(ICdmFormElement formElement,
 			ITreeNode entity, int style) {
-		selection_classification = (ClassificationSelectionElement) formFactory
-				.createSelectionElement(SelectionType.CLASSIFICATION,
+		selection_classification = formFactory
+				.createSelectionElement(Classification.class,
 						getConversationHolder(), formElement, "Classification",
-						null, ClassificationSelectionElement.DEFAULT, style);
-		selection_parentTaxonNode = (TaxonNodeSelectionElement) formFactory
-				.createSelectionElement(SelectionType.TAXON_NODE,
-						getConversationHolder(), formElement, "Parent", null,
-						TaxonNodeSelectionElement.DEFAULT, style);
-		selection_reuseExistingTaxon = (TaxonSelectionElement) formFactory
-				.createSelectionElement(SelectionType.TAXON,
+						null, EntitySelectionElement.DELETABLE, style);
+		selection_parentTaxonNode = formFactory
+				.createTaxonNodeSelectionElement(getConversationHolder(), formElement, "Parent", null,
+						EntitySelectionElement.DELETABLE, style);
+		selection_reuseExistingTaxon = formFactory
+				.createSelectionElement(Taxon.class,
 						getConversationHolder(), formElement,
 						"Reuse existing Taxon", null,
-						TaxonSelectionElement.DELETABLE, style);
+						EntitySelectionElement.NOTHING, style);
 
-		selection_reuseExistingName = (NameSelectionElement) formFactory
-				.createSelectionElement(SelectionType.NAME,
+		selection_reuseExistingName = formFactory
+				.createSelectionElement(TaxonNameBase.class,
 						getConversationHolder(), formElement,
 						"Reuse existing name", null,
-						NameSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 
 		text_newTaxonName = formFactory.createTextWithLabelElement(formElement,
 				"New Taxon", "", style);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/common/RefereneEntityDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/common/RefereneEntityDetailElement.java
index 8983d8b39..69b1e1a42 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/common/RefereneEntityDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/common/RefereneEntityDetailElement.java
@@ -10,12 +10,12 @@
 package eu.etaxonomy.taxeditor.ui.section.common;
 
 import eu.etaxonomy.cdm.model.common.ReferencedEntityBase;
+import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * @author n.hoffmann
@@ -24,7 +24,7 @@ import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
  */
 public class RefereneEntityDetailElement extends AbstractCdmDetailElement<ReferencedEntityBase>{
 
-	private ReferenceSelectionElement selection_reference;
+	private EntitySelectionElement<Reference> selection_reference;
 	private TextWithLabelElement text_referenceDetail;
 
 	public RefereneEntityDetailElement(CdmFormFactory formFactory,
@@ -35,11 +35,11 @@ public class RefereneEntityDetailElement extends AbstractCdmDetailElement<Refere
 	@Override
 	protected void createControls(ICdmFormElement formElement,
 			ReferencedEntityBase entity, int style) {
-		selection_reference = (ReferenceSelectionElement) formFactory
-				.createSelectionElement(SelectionType.REFERENCE,
+		selection_reference = formFactory
+				.createSelectionElement(Reference.class,
 						getConversationHolder(), formElement, "Reference",
 						entity.getCitation(),
-						ReferenceSelectionElement.DEFAULT, style);
+						EntitySelectionElement.ALL, style);
 		text_referenceDetail = formFactory.createTextWithLabelElement(
 				formElement, "Reference Detail",
 				entity.getCitationMicroReference(), style);
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DerivedUnitElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DerivedUnitElement.java
index 9ef0743e6..f05ea9dd5 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DerivedUnitElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DerivedUnitElement.java
@@ -12,13 +12,13 @@ package eu.etaxonomy.taxeditor.ui.section.description;
 
 import org.eclipse.swt.events.SelectionListener;
 
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.DerivedUnitBaseSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -32,7 +32,7 @@ import eu.etaxonomy.taxeditor.ui.selection.DerivedUnitBaseSelectionElement;
 public class DerivedUnitElement extends
 		AbstractEntityCollectionElement<SpecimenOrObservationBase> {
 
-	private DerivedUnitBaseSelectionElement selection_derivedUnit;
+	private EntitySelectionElement<DerivedUnitBase> selection_derivedUnit;
 
 	/**
 	 * <p>
@@ -70,9 +70,9 @@ public class DerivedUnitElement extends
 	/** {@inheritDoc} */
 	@Override
 	public void createControls(ICdmFormElement element, int style) {
-		selection_derivedUnit = (DerivedUnitBaseSelectionElement) formFactory.createSelectionElement(
-				SelectionType.DERIVED_UNIT, getConversationHolder(), element,
-				"Specimen", null, DerivedUnitBaseSelectionElement.SELECTABLE | DerivedUnitBaseSelectionElement.EDITABLE,
+		selection_derivedUnit = formFactory.createSelectionElement(
+				DerivedUnitBase.class, getConversationHolder(), element,
+				"Specimen", null, EntitySelectionElement.SELECTABLE | EntitySelectionElement.EDITABLE,
 				style);
 	}
 
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescribedSpecimenSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescribedSpecimenSection.java
index b9f915333..374fd04b7 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescribedSpecimenSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescribedSpecimenSection.java
@@ -14,7 +14,6 @@ import java.util.Collection;
 
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
-import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.occurrence.DerivedUnitBase;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 import eu.etaxonomy.taxeditor.ui.dialog.selection.DerivedUnitSelectionDialog;
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionDetailElement.java
index 7210fc710..5029bfa38 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionDetailElement.java
@@ -17,9 +17,8 @@ import eu.etaxonomy.cdm.model.description.FeatureTree;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.selection.FeatureTreeSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>DescriptionDetailElement class.</p>
@@ -31,7 +30,7 @@ import eu.etaxonomy.taxeditor.ui.selection.FeatureTreeSelectionElement;
 public class DescriptionDetailElement extends AbstractCdmDetailElement<DescriptionBase> {
 
 	private TextWithLabelElement detailDescription;
-	private FeatureTreeSelectionElement selection_featureTree;
+	private EntitySelectionElement<FeatureTree> selection_featureTree;
 
 	/**
 	 * <p>Constructor for DescriptionDetailElement.</p>
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionDetailSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionDetailSection.java
index 2166bf560..569ebb9b7 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionDetailSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionDetailSection.java
@@ -10,14 +10,13 @@
 
 package eu.etaxonomy.taxeditor.ui.section.description;
 
-import org.apache.log4j.Logger;
 import org.eclipse.jface.viewers.ISelectionProvider;
 
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.description.DescriptionBase;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
 
 /**
@@ -29,9 +28,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
  */
 public class DescriptionDetailSection extends AbstractCdmDetailSection<DescriptionBase> {
 
-	private static final Logger logger = Logger
-			.getLogger(DescriptionDetailSection.class);
-
 	/**
 	 * <p>Constructor for DescriptionDetailSection.</p>
 	 *
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementDetailElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementDetailElement.java
index d0b8cc4a8..5591416ff 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementDetailElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementDetailElement.java
@@ -10,13 +10,10 @@
 
 package eu.etaxonomy.taxeditor.ui.section.description;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailElement;
-import eu.etaxonomy.taxeditor.ui.section.description.detail.AbstractDetailedDescriptionDetailElement;
 
 /**
  * <p>DescriptionElementDetailElement class.</p>
@@ -28,11 +25,6 @@ import eu.etaxonomy.taxeditor.ui.section.description.detail.AbstractDetailedDesc
 public class DescriptionElementDetailElement extends
 		AbstractCdmDetailElement<DescriptionElementBase> {
 
-
-	private static final Logger logger = Logger
-			.getLogger(DescriptionElementDetailElement.class);
-	private AbstractDetailedDescriptionDetailElement detailElement;
-
 	/**
 	 * <p>Constructor for DescriptionElementDetailElement.</p>
 	 *
@@ -48,7 +40,7 @@ public class DescriptionElementDetailElement extends
 	/** {@inheritDoc} */
 	@Override
 	protected void createControls(ICdmFormElement formElement, DescriptionElementBase entity, int style) {
-		detailElement = formFactory.createDetailedDescriptionDetailElement(formElement, entity, style);
+		formFactory.createDetailedDescriptionDetailElement(formElement, entity, style);
 	}
 	
 	/** {@inheritDoc} */
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementDetailSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementDetailSection.java
index feb5fd0af..8f43590dd 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementDetailSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementDetailSection.java
@@ -22,8 +22,8 @@ import eu.etaxonomy.cdm.model.description.TextData;
 import eu.etaxonomy.taxeditor.store.CdmStore;
 import eu.etaxonomy.taxeditor.store.StoreUtil;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
 import eu.etaxonomy.taxeditor.ui.section.description.operation.ChangeDescriptionElementType;
 
@@ -91,9 +91,6 @@ public class DescriptionElementDetailSection extends
 		
 		toolBarManager.add(addAction);
 		
-		ICdmFormElement parentElement = this.getParentElement();
-		
-		
 		return toolBarManager.createControl(this);
 	}
 	
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementMediaSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementMediaSection.java
index bc073baca..10608b3b0 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementMediaSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementMediaSection.java
@@ -12,8 +12,6 @@ package eu.etaxonomy.taxeditor.ui.section.description;
 
 import java.util.Collection;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.Feature;
@@ -31,8 +29,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;
  */
 public class DescriptionElementMediaSection extends
 		AbstractEntityCollectionSection<DescriptionElementBase, Media> {
-	private static final Logger logger = Logger
-		.getLogger(DescriptionElementMediaSection.class);
 	
 	/**
 	 * <p>Constructor for DescriptionElementMediaSection.</p>
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementSourceElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementSourceElement.java
index 02de96a04..b74c7bfe5 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementSourceElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionElementSourceElement.java
@@ -14,14 +14,13 @@ import org.eclipse.swt.SWT;
 import org.eclipse.swt.events.SelectionListener;
 
 import eu.etaxonomy.cdm.model.common.DescriptionElementSource;
+import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.IEntityElement;
-import eu.etaxonomy.taxeditor.ui.element.SelectionArbitrator;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.supplemental.AbstractOriginalSourceElement;
-import eu.etaxonomy.taxeditor.ui.selection.NameSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -37,9 +36,7 @@ public class DescriptionElementSourceElement extends
 		AbstractOriginalSourceElement<DescriptionElementSource> implements
 		IEntityElement<DescriptionElementSource> {
 
-	private final SelectionArbitrator selectionArbitrator;
-
-	private NameSelectionElement selection_name;
+	private EntitySelectionElement<TaxonNameBase> selection_name;
 
 	/**
 	 * <p>
@@ -65,7 +62,7 @@ public class DescriptionElementSourceElement extends
 			AbstractFormSection formElement, DescriptionElementSource element,
 			SelectionListener removeListener, int style) {
 		super(cdmFormFactory, formElement, element, removeListener, style);
-		selectionArbitrator = formFactory.createSelectionArbitrator(this);
+		formFactory.createSelectionArbitrator(this);
 	}
 
 	/*
@@ -78,10 +75,10 @@ public class DescriptionElementSourceElement extends
 	@Override
 	public void createControls(ICdmFormElement formElement, int style) {
 		super.createControls(formElement, style);
-		selection_name = (NameSelectionElement) formFactory
-				.createSelectionElement(SelectionType.NAME,
+		selection_name = formFactory
+				.createSelectionElement(TaxonNameBase.class,
 						getConversationHolder(), formElement, "Name in Source",
-						null, NameSelectionElement.DEFAULT, SWT.NULL);
+						null, EntitySelectionElement.ALL, SWT.NULL);
 	}
 
 	/*
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionSourceElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionSourceElement.java
index 8b6ff3996..a25880201 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionSourceElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/DescriptionSourceElement.java
@@ -16,9 +16,8 @@ import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
-import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.SelectionType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
-import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
+import eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement;
 
 /**
  * <p>
@@ -32,7 +31,7 @@ import eu.etaxonomy.taxeditor.ui.selection.ReferenceSelectionElement;
 public class DescriptionSourceElement extends
 		AbstractEntityCollectionElement<Reference> {
 
-	private ReferenceSelectionElement selection_descriptionSource;
+	private EntitySelectionElement<Reference> selection_descriptionSource;
 
 	/**
 	 * <p>
@@ -62,10 +61,10 @@ public class DescriptionSourceElement extends
 	/** {@inheritDoc} */
 	@Override
 	public void createControls(ICdmFormElement element, int style) {
-		selection_descriptionSource = (ReferenceSelectionElement) formFactory
-				.createSelectionElement(SelectionType.REFERENCE,
+		selection_descriptionSource = formFactory
+				.createSelectionElement(Reference.class,
 						getConversationHolder(), element, "Description Source",
-						null, ReferenceSelectionElement.DEFAULT, style);
+						null, EntitySelectionElement.ALL, style);
 	}
 
 	/** {@inheritDoc} */
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/GeoScopeSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/GeoScopeSection.java
index 9c158503f..b8a69e0ae 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/GeoScopeSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/GeoScopeSection.java
@@ -12,8 +12,6 @@ package eu.etaxonomy.taxeditor.ui.section.description;
 
 import java.util.Collection;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.location.NamedArea;
@@ -30,10 +28,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;
  */
 public class GeoScopeSection extends AbstractEntityCollectionSection<TaxonDescription, NamedArea> {
 	
-
-	private static final Logger logger = Logger
-			.getLogger(GeoScopeSection.class);
-
 	/**
 	 * <p>Constructor for GeoScopeSection.</p>
 	 *
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/MediaDetailsSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/MediaDetailsSection.java
index 3f11b081b..f82b59c3c 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/MediaDetailsSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/MediaDetailsSection.java
@@ -10,7 +10,6 @@
 
 package eu.etaxonomy.taxeditor.ui.section.description;
 
-import org.apache.log4j.Logger;
 import org.eclipse.jface.viewers.ISelectionProvider;
 import org.eclipse.ui.forms.widgets.Section;
 import org.eclipse.ui.forms.widgets.TableWrapLayout;
@@ -18,8 +17,8 @@ import org.eclipse.ui.forms.widgets.TableWrapLayout;
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
 import eu.etaxonomy.taxeditor.ui.section.media.MediaElement;
 
@@ -32,9 +31,6 @@ import eu.etaxonomy.taxeditor.ui.section.media.MediaElement;
  */
 public class MediaDetailsSection extends AbstractCdmDetailSection<Media> {
 
-
-	private static final Logger logger = Logger
-			.getLogger(MediaDetailsSection.class);
 	private MediaElement element_media;
 
 	/**
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/ModifierSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/ModifierSection.java
index 86ec0a453..3025ad0b3 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/ModifierSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/ModifierSection.java
@@ -12,8 +12,6 @@ package eu.etaxonomy.taxeditor.ui.section.description;
 
 import java.util.Collection;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.description.IModifiable;
 import eu.etaxonomy.cdm.model.description.Modifier;
@@ -30,10 +28,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;
  */
 public class ModifierSection extends AbstractEntityCollectionSection<IModifiable, Modifier> {
 
-
-	private static final Logger logger = Logger
-			.getLogger(ModifierSection.class);
-
 	/**
 	 * <p>Constructor for ModifierSection.</p>
 	 *
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/NaturalLanguageSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/NaturalLanguageSection.java
index d7d7a40b9..e073f7e3a 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/NaturalLanguageSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/NaturalLanguageSection.java
@@ -10,14 +10,13 @@
 
 package eu.etaxonomy.taxeditor.ui.section.description;
 
-import org.apache.log4j.Logger;
 import org.eclipse.jface.viewers.ISelectionProvider;
 
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
-import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.DetailType;
+import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
 import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
 
 /**
@@ -29,10 +28,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractCdmDetailSection;
  */
 public class NaturalLanguageSection extends AbstractCdmDetailSection<TaxonDescription> {
 	
-
-	private static final Logger logger = Logger
-			.getLogger(NaturalLanguageSection.class);
-
 	/**
 	 * <p>Constructor for NaturalLanguageSection.</p>
 	 *
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/ScopeSection.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/ScopeSection.java
index 017cda80c..04038711c 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/ScopeSection.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/ScopeSection.java
@@ -12,8 +12,6 @@ package eu.etaxonomy.taxeditor.ui.section.description;
 
 import java.util.Collection;
 
-import org.apache.log4j.Logger;
-
 import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
 import eu.etaxonomy.cdm.model.description.Scope;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
@@ -30,9 +28,6 @@ import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection;
  */
 public class ScopeSection extends AbstractEntityCollectionSection<TaxonDescription, Scope> {
 
-
-	private static final Logger logger = Logger.getLogger(ScopeSection.class);
-
 	/**
 	 * <p>Constructor for ScopeSection.</p>
 	 *
diff --git a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StateDataElement.java b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StateDataElement.java
index ddd00dc45..f87cf6f88 100644
--- a/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StateDataElement.java
+++ b/eu.etaxonomy.taxeditor.store/src/main/java/eu/etaxonomy/taxeditor/ui/section/description/StateDataElement.java
@@ -21,6 +21,7 @@ import eu.etaxonomy.taxeditor.ui.combo.TermComboElement;
 import eu.etaxonomy.taxeditor.ui.element.AbstractFormSection;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory;
 import eu.etaxonomy.taxeditor.ui.element.ICdmFormElement;
+import eu.etaxonomy.taxeditor.ui.element.LayoutConstants;
 import eu.etaxonomy.taxeditor.ui.element.TextWithLabelElement;
 import eu.etaxonomy.taxeditor.ui.element.CdmFormFactory.EntityDetailType;
 import eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionElement;
@@ -68,7 +69,7 @@ public class StateDataElement extends AbstractEntityCollectionElement<StateData>
 	public void createControls(ICdmFormElement element, int style) {
 		combo_state = formFactory.createTermComboElement(State.class, element, "State", null, style);
 		section_modifiers = (ModifierSection) formFactory.createEntityDetailSection(EntityDetailType.MODIFIER, getConversationHolder(), element, Section.TWISTIE);
-		section_modifiers.setLayoutData(CdmFormFactory.FILL_HORIZONTALLY(2, 1));
+		section_modifiers.setLayoutData(LayoutConstants.FILL_HORIZONTALLY(2, 1));
 		text_modifyingText = formFactory.createTextWithLabelElement(element, "Modifying Text", null, style);
 	}
 
@@ -79,7 +80,7 @@ public class StateDataElement extends AbstractEntityCollectionElement<StateData>
 			getEntity().setState(combo_state.getSelection());
 		}
 		if(eventSource == text_modifyingText){
-			getEntity().addModifyingText(LanguageString.NewInstance(text_modifyingText.getText(), CdmStore.getDefaultLanguage()));
+			getEntity().putModifyingText(LanguageString.NewInstance(text_modifyingText.getText(), CdmStore.getDefaultLanguage()));
 		}
 	}
 }
